//
//  PlayerMovesService.swift
//  GoldWars
//
//  Created by Tim Herbst on 13.05.20.
//  Copyright © 2020 SP2. All rights reserved.
//

struct PlayerMove: Codable{
    let fromBase: Int
    let toBase: Int
    let unitCount: Int
}

struct Host: Codable {
    let playerID: String
}

class DataService {
    static let sharedInstance = DataService()
    var localPlayerMoves: [PlayerMove] = []
    var remotePlayerMoves: [String: [PlayerMove]] = [:]
    var gameHost: Host?

    
    func addMove(playerMove: PlayerMove) {
        self.localPlayerMoves.append(playerMove)
    }
    
    func addRemotePlayerMoves(playerID: String, playerMoves: [PlayerMove]) {
        self.remotePlayerMoves[playerID] = playerMoves
        
        //test
        var size = self.remotePlayerMoves.count
        if size == 1 {
            for (key, value) in remotePlayerMoves {
                print("\(key) : \(value)")
            }
        }
    }
    
    func setGameHost(host: Host) {
        self.gameHost = host
    }
}
