//
//  Base.swift
//  GoldWars
//
//  Created by Marcel Schwarz on 18.04.20.
//  Copyright © 2020 SP2. All rights reserved.
//

import SpriteKit
import GameplayKit

class Base: GKEntity{
    static var BASE_ID_COUNT: Int = 0
    var unitCount: Int
    var adjacencyList: Array<Base>
    var changeOwnerShip: Bool
    var baseID: Int
    
    init(position: CGPoint, team: Team! = nil) {
        self.unitCount = 0
        self.adjacencyList = [Base]()
        self.changeOwnerShip = false
        baseID = Base.BASE_ID_COUNT
        Base.BASE_ID_COUNT += 1
        super.init()
        
        addComponent(DefaultBaseComponent(texture: SKTexture(imageNamed: "Base"), position: position))
        if(team != nil){
            addComponent(TeamComponent(team: team!, position: position))
            self.unitCount = 500
        }
    }
    
    func attackBase(base: Base, units: Int) -> [GKEntity]{
        base.changeOwnerShip = true
        self.unitCount -= units
        base.unitCount += units
        DataService.sharedInstance.addMove(playerMove: PlayerMove(fromBase: self.baseID, toBase: base.baseID, unitCount: units))
        return [self, base]
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
