//
//  MultiplayerNetwork.swift
//  GoldWars
//
//  Created by Niko Jochim on 10.05.20.
//  Copyright © 2020 SP2. All rights reserved.
//

import GameplayKit
import Foundation
import GameKit

class MultiplayerNetwork{
	static let sharedInstance = MultiplayerNetwork()
    var isSending = false
    
	func sendData(data: Data) {
		let mmHelper = MatchmakingHelper.sharedInstance
		if let multiplayerMatch = mmHelper.mpMatch {
			do {
				try multiplayerMatch.sendData(toAllPlayers: data, with: .reliable)
			} catch {
				print("Tim war am Werk")
			}
		}
	}
    
    func sendDataToHost(data: Data) {
        let mmHelper = MatchmakingHelper.sharedInstance
        for player in mmHelper.mpMatch!.players {
            print(player.displayName)
        }
        print(DataService.sharedInstance.gameHost!.playerID)
        
        let hostGKPlayer = MatchmakingHelper.sharedInstance.mpMatch?.players.filter{ $0.displayName == DataService.sharedInstance.gameHost!.playerID}[0]
        
        if let multiplayerMatch = mmHelper.mpMatch{
            do {
                try multiplayerMatch.send(data, to: [hostGKPlayer!], dataMode: .reliable)
            } catch {
                print("Tim war mal wieder am Werk der Krasse")
            }
        }
    }

    func sendPlayerMoves(playerMoves: [PlayerMove]) {
        if MatchmakingHelper.sharedInstance.isServer == false {
            self.isSending = true
            let encoder = JSONEncoder()
            let encoded = (try? encoder.encode(playerMoves))!
            sendDataToHost(data: encoded)
        }
	}
    
    func sendHostIdentifier() {
        let encoder = JSONEncoder()
        let encoded = (try? encoder.encode(DataService.sharedInstance.gameHost))!
        sendData(data: encoded)
    }

}
